#include <bits/stdc++.h>
using namespace std;
int main()
{
    int t;
    long long x,k,n,m;
    cin>>t;
    while(t)
    {
        long long min1=1e18,min2=1e18;
        int r=0;
        cin>>n>>m;
        long long a[n],b[m];
        for(int i=0; i<n; i++)
        {
            cin>>a[i];
            if(a[i]<min1)
            {
                min2=min1;
                min1=a[i];
            }
            if(a[i]<min2 && a[i]>min1)
                min2=a[i];
        }
        for(int i=0; i<m; i++)
            cin>>b[i];
        x=min2-min1;
        k=a[0]%x;
        for(int i=0; i<n-1; i++)
        {
            if(abs(a[i+1]-a[i])%x!=0)
            {
                r=2;
                break;
            }
        }
        for(int i=0; i<m; i++)
        {
            if(b[i]%x==k)
            {
                r=2;
                break;
            }
        }
        if(r==2)
            cout<<0<<endl;
        else
            cout<<1<<endl;
        t--;
    }
    return 0;
}